local K, C = unpack(select(2, ...))
if not C["General"].DisableTutorialButtons or K.CheckAddOnState("TutorialBuster") then
	return
end

local Module = K:NewModule("NoTutorials", "AceEvent-3.0")

local _G = _G
local pairs = pairs
local tonumber = tonumber

local GetCVar = _G.GetCVar
local SetCVar = _G.SetCVar
local GetCVarBitfield = _G.GetCVarBitfield
local SetCVarBitfield = _G.SetCVarBitfield

local MAX_BIT_FLAGS_TUTORIAL = 4294934528

Module.CVarFields = {
	"lastVoidStorageTutorial",
	"shipyardMissionTutorialAreaBuff",
	"shipyardMissionTutorialBlockade",
	"shipyardMissionTutorialFirst",
}

Module.BitFields = {
	LE_FRAME_TUTORIAL_ARTIFACT_APPEARANCE_TAB,
	LE_FRAME_TUTORIAL_ARTIFACT_KNOWLEDGE,
	LE_FRAME_TUTORIAL_ARTIFACT_RELIC_MATCH,
	LE_FRAME_TUTORIAL_AZERITE_FIRST_POWER_LOCKED_IN,
	LE_FRAME_TUTORIAL_AZERITE_ITEM_IN_BAG,
	LE_FRAME_TUTORIAL_AZERITE_ITEM_IN_SLOT,
	LE_FRAME_TUTORIAL_AZERITE_RESPEC,
	LE_FRAME_TUTORIAL_BAG_SETTINGS,
	LE_FRAME_TUTORIAL_BAG_SLOTS_AUTHENTICATOR,
	LE_FRAME_TUTORIAL_BONUS_ROLL_ENCOUNTER_JOURNAL_LINK,
	LE_FRAME_TUTORIAL_BOOSTED_SPELL_BOOK,
	LE_FRAME_TUTORIAL_BOUNTY_FINISHED,
	LE_FRAME_TUTORIAL_BOUNTY_INTRO,
	LE_FRAME_TUTORIAL_BRAWL,
	LE_FRAME_TUTORIAL_CHAT_CHANNELS,
	LE_FRAME_TUTORIAL_CLEAN_UP_BAGS,
	LE_FRAME_TUTORIAL_FRIENDS_LIST_QUICK_JOIN,
	LE_FRAME_TUTORIAL_GAME_TIME_AUCTION_HOUSE,
	LE_FRAME_TUTORIAL_GARRISON_BUILDING,
	LE_FRAME_TUTORIAL_GARRISON_LANDING,
	LE_FRAME_TUTORIAL_GARRISON_ZONE_ABILITY,
	LE_FRAME_TUTORIAL_HEIRLOOM_JOURNAL,
	LE_FRAME_TUTORIAL_HEIRLOOM_JOURNAL_LEVEL,
	LE_FRAME_TUTORIAL_HEIRLOOM_JOURNAL_TAB,
	LE_FRAME_TUTORIAL_HONOR_TALENT_FIRST_TALENT,
	LE_FRAME_TUTORIAL_HONOR_TALENT_HONOR_LEVELS,
	LE_FRAME_TUTORIAL_INVENTORY_FIXUP_CHECK_EXPANSION_LEGION,
	LE_FRAME_TUTORIAL_INVENTORY_FIXUP_EXPANSION_LEGION,
	LE_FRAME_TUTORIAL_INVENTORY_FIXUP_EXPANSION_LEGION,
	LE_FRAME_TUTORIAL_ISLANDS_QUEUE_BUTTON,
	LE_FRAME_TUTORIAL_ISLANDS_QUEUE_INFO_FRAME,
	LE_FRAME_TUTORIAL_LFG_LIST,
	LE_FRAME_TUTORIAL_PET_JOURNAL,
	LE_FRAME_TUTORIAL_PROFESSIONS,
	LE_FRAME_TUTORIAL_PVP_TALENTS_FIRST_UNLOCK,
	LE_FRAME_TUTORIAL_PVP_WARMODE_UNLOCK,
	LE_FRAME_TUTORIAL_REAGENT_BANK_UNLOCK,
	LE_FRAME_TUTORIAL_RELIC_FORGE_LEARN_TRAIT,
	LE_FRAME_TUTORIAL_RELIC_FORGE_PREVIEW_RELIC,
	LE_FRAME_TUTORIAL_RELIC_FORGE_SOCKETED_RELIC,
	LE_FRAME_TUTORIAL_REPUTATION_EXALTED_PLUS,
	LE_FRAME_TUTORIAL_SPEC,
	LE_FRAME_TUTORIAL_SPELLBOOK,
	LE_FRAME_TUTORIAL_TALENT,
	LE_FRAME_TUTORIAL_TOYBOX,
	LE_FRAME_TUTORIAL_TOYBOX_FAVORITE,
	LE_FRAME_TUTORIAL_TOYBOX_MOUSEWHEEL_PAGING,
	LE_FRAME_TUTORIAL_TRADESKILL_RANK_STAR,
	LE_FRAME_TUTORIAL_TRADESKILL_UNLEARNED_TAB,
	LE_FRAME_TUTORIAL_TRANSMOG_JOURNAL_TAB,
	LE_FRAME_TUTORIAL_TRANSMOG_MODEL_CLICK,
	LE_FRAME_TUTORIAL_TRANSMOG_OUTFIT_DROPDOWN,
	LE_FRAME_TUTORIAL_TRANSMOG_SETS_TAB,
	LE_FRAME_TUTORIAL_TRANSMOG_SETS_VENDOR_TAB,
	LE_FRAME_TUTORIAL_TRANSMOG_SPECS_BUTTON,
	LE_FRAME_TUTORIAL_TRIAL_BANKED_XP,
	LE_FRAME_TUTORIAL_WARFRONT_CONSTRUCTION,
	LE_FRAME_TUTORIAL_WARFRONT_RESOURCES,
	LE_FRAME_TUTORIAL_WORLD_MAP_FRAME,
	LE_FRAME_TUTORIAL_X,
}

function Module:PLAYER_ENTERING_WORLD()
	if (not GetCVar("lastGarrisonMissionTutorial") or tonumber(GetCVar("lastGarrisonMissionTutorial")) < MAX_BIT_FLAGS_TUTORIAL) then
		SetCVar("lastGarrisonMissionTutorial", MAX_BIT_FLAGS_TUTORIAL)
	end

	if (not GetCVar("orderHallMissionTutorial") or tonumber(GetCVar("orderHallMissionTutorial")) < MAX_BIT_FLAGS_TUTORIAL) then
		SetCVar("orderHallMissionTutorial", MAX_BIT_FLAGS_TUTORIAL)
	end

	local _, field
	for _, field in pairs(Module.CVarFields) do
		if (tonumber(GetCVar(field)) == 0) then
			SetCVar(field, 1)
		end
	end

	for _, field in pairs(Module.BitFields) do
		if (not GetCVarBitfield("closedInfoFrames", field)) then
			SetCVarBitfield("closedInfoFrames", field, true)
		end
	end

	self:UnregisterEvent("ADDON_LOADED")
end

function Module:OnEnable()
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
end

function Module:OnDisable()
	self:UnregisterEvent("PLAYER_ENTERING_WORLD")
end
